#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 200 * 1000 + 228;

int n;
vector<int> g[MAX_N]; 
ll cost[MAX_N];
ll mn[MAX_N];
ll sum[MAX_N];
int sz[MAX_N];
ll ans = 0;

bool cmp(int a, int b)
{
	return sz[a] > sz[b];
}

void dfs(int v)
{
	sz[v] = 1;
	mn[v] = cost[v];
	sum[v] = cost[v];

	if (g[v].empty()) return;

	for (int i = 0; i < (int)g[v].size(); ++i)
	{
		int to = g[v][i];
		dfs(to);
		
		mn[v] = min(mn[v], mn[to]);
		sz[v] += sz[to];
		sum[v] += sum[to];
	}
	ans += sum[v] - cost[v]; 
	sort(g[v].begin(), g[v].end(), cmp);

	for (int i = 0; i < (int)g[v].size(); ++i)
	{
		for (int j = i + 1; j < (int)g[v].size(); ++j)
		{
			if (sz[g[v][i]] <= sz[g[v][j]]) 
			{
				sz[g[v][j]] -= sz[g[v][i]];
				sz[g[v][i]] = 0;
			}
			else
			{
				sz[g[v][i]] -= sz[g[v][j]];
				sz[g[v][j]] = 0;
			}
		}
	}

	if (sz[g[v][0]] > 0)
	{
		ll to_add = mn[g[v][1]];
		for (int i = 2; i < (int)g[v].size(); ++i) to_add = min(to_add, mn[g[v][i]]);
		ans += to_add * sz[g[v][0]];
	}
	else if (sz[v] % 2 == 0) 
	{
		ll to_add = mn[g[v][0]];
		for (int i = 1; i < (int)g[v].size(); ++i) to_add = min(to_add, mn[g[v][i]]);
		ans += to_add;
	}
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d", &n);
	for (int i = 1; i < n; ++i) 
	{
		int v;
		scanf("%d", &v);
		--v;
		g[v].push_back(i);
	}
	
	for (int i = 1; i < n; ++i) scanf("%lld", &cost[i]);

	dfs(0);

	printf("%lld\n", ans);

	return 0;
}

